REM http://download.osgeo.org/gdal/2.0.2/gdal-2.0.2.tar.gz

REM Other Sources:
REM http://downloads2.esri.com/Software/FileGDB_API_VS2010_1_3.zip
REM http://downloada.erdas.com/software/2013/ECWJP2SDK/erdas-ecwjp2sdk-v5.0-windows.zip
REM https://www.lizardtech.com/download/developer/MrSID_DSDK-8.5.0.3422-win32-vs10.zip
REM https://www.lizardtech.com/download/developer/MrSID_DSDK-8.5.0.3422-win64-vs10.zip

set ARCH=%1
if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set BITS=32
	set VCARCH=x86
	set ECWARCH=win32
	set FGBDARCH=
	set HINT=gdal32.hint
) else (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set BITS=64
	set VCARCH=x64
	set ECWARCH=x64
	set FGBDARCH=64
	set HINT=gdal.hint
)

call %OSGEO4W_ROOT%\bin\o4w_env.bat
echo on

set P=gdal
set V=2.0.2
set B=5

set EXT_NMAKE_OPT=%CD%\nmake%BITS%.opt
set FGDB_SDK=%CD%\..\..\filegdb
set ECW_SDK=%CD%\..\..\ecw-5
set MRSID_SDK=%CD%\..\..\MrSID_DSDK-8.5.0.3422-win%BITS%-vs10

set R=..\..\..\%ARCH%\release\%P%
for %%i in (python oracle filegdb ecw mrsid sosi) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
)

set DESTDIR=%CD%\install%BITS%
set PYDESTDIR=%CD%\pyinstall%BITS%
if exist %DESTDIR% rmdir /s /q %DESTDIR%
if exist %PYDESTDIR% rmdir /s /q %PYDESTDIR%
mkdir %DESTDIR%\etc\ini
mkdir %DESTDIR%\share\gdal

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" %VCARCH%
echo on
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%

copy ini.bat %DESTDIR%\etc\ini\%P%.bat

mkdir %PYDESTDIR%\etc\postinstall
copy %P%-python.postinstall %PYDESTDIR%\etc\postinstall\%P%-python.bat

copy %HINT% %R%\setup.hint
copy %P%-python.hint %R%\%P%-python\setup.hint
copy %P%-oracle.hint %R%\%P%-oracle\setup.hint
copy %P%-filegdb.hint %R%\%P%-filegdb\setup.hint
copy %P%-ecw.hint %R%\%P%-ecw\setup.hint
copy %P%-mrsid.hint %R%\%P%-mrsid\setup.hint
copy %P%-sosi.hint %R%\%P%-sosi\setup.hint

copy ..\LICENSE.TXT %R%\%P%-%V%-%B%.txt
copy ..\LICENSE.TXT %R%\%P%-python\%P%-python-%V%-%B%.txt
copy ..\LICENSE.TXT %R%\%P%-oracle\%P%-oracle-%V%-%B%.txt
copy %FGDB_SDK%\license\userestrictions.txt %R%\%P%-filegdb\%P%-filegdb-%V%-%B%.txt
copy %ECW_SDK%\EULA.rtf %R%\%P%-ecw\%P%-ecw-%V%-%B%.rtf
copy %MRSID_SDK%\LICENSE.pdf %R%\%P%-mrsid\%P%-mrsid-%V%-%B%.pdf

cd ..

PATH %PATH%;%OSGEO4W_ROOT%\bin;c:\cygwin\bin

if not exist osgeo4w\patched-plugin-clean patch -p1 <osgeo4w\plugin-clean.diff >osgeo4w\patched-plugin-clean
if not exist osgeo4w\patched-vsizip patch -p1 <osgeo4w\vsizip.diff >osgeo4w\patched-vsizip
if not exist osgeo4w\patched-pgcopy patch -p1 <osgeo4w\pgcopy.diff >osgeo4w\patched-pgcopy

for %%i in (clean default install devinstall) do (
	if not exist osgeo4w\no%%i (
		nmake /f makefile.vc EXT_NMAKE_OPT=%EXT_NMAKE_OPT% GDAL_HOME=%DESTDIR% FGDB_SDK=%FGDB_SDK% ECWDIR=%ECW_SDK% MRSID_SDK=%MRSID_SDK% %%i
		if errorlevel 1 (echo make %%i & goto error)
	)
)

if exist osgeo4w\nopackage exit

cd swig

nmake /f makefile.vc EXT_NMAKE_OPT=%EXT_NMAKE_OPT% python
if errorlevel 1 (echo python make error & goto error)

cd python
mkdir %PYDESTDIR%\apps\%P%\python
%OSGEO4W_ROOT%\bin\python.exe setup.py install --prefix=%PYDESTDIR%\apps\python27 --single-version-externally-managed --record ..\..\osgeo4w\record.log
if errorlevel 1 (echo python install error & goto error)

mkdir %PYDESTDIR%\bin
copy scripts\*.py %PYDESTDIR%\bin

cd ..\..\osgeo4w

copy %FGDB_SDK%\bin%FGDBARCH%\FileGDBAPI.dll %DESTDIR%\bin
copy %ECW_SDK%\bin\vc100\%ECWARCH%\NCSEcw.dll %DESTDIR%\bin
copy %MRSID_SDK%\Raster_DSDK\lib\lti_dsdk_cdll.dll %DESTDIR%\bin
copy %MRSID_SDK%\Raster_DSDK\lib\lti_dsdk.dll %DESTDIR%\bin
copy %MRSID_SDK%\Lidar_DSDK\lib\lti_lidar_dsdk.dll %DESTDIR%\bin

set R=%R:\=/%
tar -C pyinstall%BITS% --exclude="*.pyc" -cjvf %R%/%P%-python/%P%-python-%V%-%B%.tar.bz2 apps/Python27 bin etc
tar -C install%BITS% --remove-files -cjvf %R%/%P%-filegdb/%P%-filegdb-%V%-%B%.tar.bz2 bin/gdalplugins/ogr_FileGDB.dll bin/FileGDBAPI.dll
tar -C install%BITS% --remove-files -cjvf %R%/%P%-sosi/%P%-sosi-%V%-%B%.tar.bz2 bin/gdalplugins/ogr_SOSI.dll
tar -C install%BITS% --remove-files -cjvf %R%/%P%-oracle/%P%-oracle-%V%-%B%.tar.bz2 bin/gdalplugins/gdal_GEOR.dll bin/gdalplugins/ogr_OCI.dll
tar -C install%BITS% --remove-files -cjvf %R%/%P%-ecw/%P%-ecw-%V%-%B%.tar.bz2 bin/gdalplugins/gdal_ECW_JP2ECW.dll bin/NCSEcw.dll
tar -C install%BITS% --remove-files -cjvf %R%/%P%-mrsid/%P%-mrsid-%V%-%B%.tar.bz2 bin/gdalplugins/gdal_MG4Lidar.dll bin/gdalplugins/gdal_MrSID.dll bin/lti_dsdk_cdll.dll bin/lti_lidar_dsdk.dll bin/lti_dsdk.dll
tar -C install%BITS% --remove-files -cjvf %R%/%P%-%V%-%B%.tar.bz2 bin etc include lib share
tar -C .. -cjvf %R%/%P%-%V%-%B%-src.tar.bz2 ^
	osgeo4w/%HINT% ^
	osgeo4w/gdal-ecw.hint ^
	osgeo4w/gdal-filegdb.hint ^
	osgeo4w/gdal-mrsid.hint ^
	osgeo4w/gdal-oracle.hint ^
	osgeo4w/gdal-python.hint ^
	osgeo4w/gdal-sosi.hint ^
	osgeo4w/gdal-python.postinstall ^
	osgeo4w/ini.bat ^
	osgeo4w/plugin-clean.diff ^
	osgeo4w/vsizip.diff ^
	osgeo4w/pgcopy.diff ^
	osgeo4w/nmake%BITS%.opt ^
	osgeo4w/package.cmd

exit

:error
